#include <iostream>
#include <complex>
#include <fstream>

using namespace std;

int main(){
	const double PI = 3.14159265358979;

	const int N = 1000;	//関数のデータ点
	const int N_s = 100;	//単スリットの分割数
	//const int N_w = 100;	//ダブルスリットの分割数
	const int N_l = 100;

	const double x_max = 500.0;
	const double x_min = .0;

	const double c = .8;
	const double a = 0.5;
	const double b = 0.15;
	const double d = 5.0;

	const double L_1 = 200.0;
	const double L_2 = 500.0;
	const double L_0 = 70.0;

	const double lambda = 0.000637;
	const double k = 2*PI/lambda;

	ofstream ofs("widesingle.txt");

	for(int i=0;i<N;i++){
		complex<double> f(.0,.0);
		double x = x_min + (x_max-x_min)*i/N;


		for(int j=0;j<N_s;j++){	//単スリット
			double du = c/N_s;
			double u = -c/2 + j*du;

			complex<double> s1(.0, k*u*(u-x)/(L_1+L_2));
			
			for(int m=0;m<N_l;m++){	//LED
				double dw = d/N_l;
				double w = -d/2 + m*dw;

				complex<double> r(.0,k*w*(w-u)/L_0);

				f += exp(r+s1);
			}
		}
		f /= (N_s*N_l);

		cout << "x = " << x << ", |f(x)| = " << abs(f) << endl;
		ofs << x << " " << abs(f) << endl;
	}


	return 0;
}
