#include <iostream>
#include <complex>
#include <fstream>

using namespace std;

int main(){
	const double PI = 3.14159265358979;

	const int N = 1000;	//関数のデータ点
	const int N_s = 100;	//単スリットの分割数
	const int N_w = 100;	//ダブルスリットの分割数

	const double x_max = 4.0;
	const double x_min = .0;

	const double c = 0.8;
	const double a = 0.5;
	const double b = 0.15;

	const double L_1 = 200.0;
	const double L_2 = 500.0;

	const double lambda = 0.000637;
	const double k = 2*PI/lambda;

	ofstream ofs("doubleslit.txt");

	for(int i=0;i<N;i++){
		complex<double> f(.0,.0);
		double x = x_min + (x_max-x_min)*i/N;

		for(int l=0;l<N_w;l++){	//ダブルスリット
			double dv = b/N_w;
			double v = a/2 - b/2 + l*dv;

			complex<double> t1(.0, k*v*(v-x)/L_2);
			complex<double> t2(.0, k*(-v)*(-v-x)/L_2);

			for(int j=0;j<N_s;j++){	//単スリット
				double du = c/N_s;
				double u = -c/2 + j*du;

				complex<double> s1(.0, k*u*(u-v)/L_1);
				complex<double> s2(.0, k*u*(u+v)/L_1);

				f += exp(s1+t1) + exp(s2+t2);
			}
		}
		f /= (N_w*N_s*2.0);

		cout << "x = " << x << ", |f(x)| = " << abs(f) << endl;
		ofs << x << " " << abs(f) << endl;
	}


	return 0;
}
