#include <iostream>
#include <complex>
#include <fstream>

using namespace std;

int main(){
	const double PI = 3.14159265358979;

	const int N = 10000;	//関数のデータ点
	const int N_s = 100;	//単スリットの分割数
	//const int N_w = 1000;	//ダブルスリットの分割数

	const double x_max = 20.0;	//関数の最大値
	const double x_min = .0;	//関数の最小値

	const double c = 0.8;		//単スリットの幅（単位mm、以下同様）
	//const double a = 0.5;		//二重スリットの間隔
	//const double b = 0.15;	//二重スリットの幅

	const double L_1 = 200.0;	//単スリットから二重スリットまでの距離
	const double L_2 = 500.0;	//二重スリットからスクリーンまでの距離

	const double lambda = 0.000637;	//LEDの波長
	const double k = 2*PI/lambda;	//LEDの波数

	ofstream ofs("singleslit.txt");	//計算結果書き出しファイル

	for(int i=0;i<N;i++){	//各xについて計算する
		complex<double> f(.0,.0);
		double x = x_min + (x_max-x_min)*i/N;

		for(int j=0;j<N_s;j++){	//単スリットの各点について和を取る
			double du = c/N_s;
			double u = -c/2 + j*du;
			complex<double> s(.0, k*u*(u-x)/(L_1+L_2));	//ik×(光路差)
			f += exp(s);
		}
		f /= N_s;						//規格化

		cout << "x = " << x << ", |f(x)| = " << abs(f) << endl;	//標準出力
		ofs << x << " " << abs(f) << endl;			//ファイル出力
	}


	return 0;
}
