#include <iostream>
#include <complex>
#include <fstream>

using namespace std;

const double PI = 3.14159265358979;

double LED(double _w){
	const double sigma = 12.5;
	return 1/sqrt(2*PI)/sigma * exp( -0.5*pow(_w/sigma,2.0) );
}

int main(){

	const int N = 1000;	//関数のデータ点
	const int N_s = 100;	//単スリットの分割数
	//const int N_w = 100;	//ダブルスリットの分割数
	const int N_l = 100;

	const double x_max = 20.0;
	const double x_min = .0;

	const double c = .8;
	const double a = 0.5;
	const double b = 0.15;
	const double d = 5.0;

	const double L_1 = 200.0;
	const double L_2 = 500.0;
	const double L_0 = 70.0;

	const double lambda = 0.000637;
	const double k = 2*PI/lambda;

	ofstream ofs("conv_singleslit.txt");

	double norm;

	for(int i=0;i<N;i++){
		//complex<double> f(.0,.0);
		double f2 = .0;
		double x = x_min + (x_max-x_min)*i/N;

		for(int l=0;l<N_l;l++){
			double dw = d/N_l;
			double w = -d/2 + l*dw;

			complex<double> g(.0,.0);
			for(int j=0;j<N_s;j++){	//単スリット
				double du = c/N_s;
				double u = -c/2 + j*du;

				complex<double> s1(.0, k*u*( (u-x)/(L_1+L_2) + (u-w)/L_0 ));
				
				g += LED(w) *exp(s1);	
				
			}
			f2 += pow(abs(g),2.0);
		}
		f2 /= N_s;

		if(i==0){norm = f2;}
		f2/=norm;
		cout << "x = " << x << ", |f(x)| = " << f2 << endl;
		ofs << x << " " << f2 << endl;
	}


	return 0;
}
